/*************************************************************************
 * ERWon - Entity Relationship for Windows or Not
 * Ricardo Drizin
 * 
 * Objetos de banco de dados - coleo de colunas, indices, etc.
 * Em desenvolvimento
 ************************************************************************/

using System;
using System.ComponentModel;
using System.Drawing;
using System.Runtime.Serialization;
using System.Data;

namespace ERWon
{



	//TODO - talvez isso seja necessrio no futuro - http://msdn.microsoft.com/library/default.asp?url=/library/en-us/cpref/html/frlrfsystemruntimeserializationiobjectreferenceclasstopic.asp
	// por enquanto tudo parece ok... referencias ao mesmo objeto (ex:indices) sao serializados s uma vez...
	[Serializable]
	public class Column : DataColumn, ISerializable
	{
		public string typeName;
		public bool NOTNULL;
		public Column(string columnName, string typeName, bool NOTNULL) : base(columnName, typeof(Int32))
		{
			this.typeName = typeName;
			this.NOTNULL = NOTNULL;
		}
		protected Column (SerializationInfo Info, StreamingContext Context) : base("tempname", typeof(Int32))
		{
			this.ColumnName = Info.GetString("ColumnName");
			this.typeName = Info.GetString("typeName");
			this.NOTNULL = Info.GetBoolean("NOTNULL");
		}

		public void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			info.AddValue("ColumnName", this.ColumnName);
			info.AddValue("typeName", this.typeName);
			info.AddValue("NOTNULL", this.NOTNULL);
		}

	}

	[Serializable]
	public class ColumnCollection  : ISerializable
		//: System.Collections.IList
	{
		public Column[] m_Columns;

		public ColumnCollection()
		{
			m_Columns = new Column[0];
		}

		public virtual void AddColumn(Column col)
		{
			Column[] m_Columns2 = new Column[m_Columns.GetLength(0)+1];
			m_Columns.CopyTo(m_Columns2, 0);
			m_Columns2[m_Columns.GetLength(0)] = col;
			m_Columns = m_Columns2 ;
		}
		public virtual void DelColumn(Column col)
		{
			Column[] m_Columns2 = new Column[m_Columns.GetLength(0)-1];
			int i=0, j=0;
			for (; i<=m_Columns2.GetLength(0)-1; i++, j++) 
			{
				if (m_Columns[j].Equals(col)) 
					j++;
				m_Columns2[i] = m_Columns[j];
			}
			m_Columns = m_Columns2 ;
		}

		/// <summary>Construtor Serializao</summary>
		protected ColumnCollection (SerializationInfo Info, StreamingContext Context)
		{
			m_Columns = Info.GetValue("m_Columns", typeof(Column[])) as Column[];
		}
		public virtual void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			info.AddValue("m_Columns", m_Columns);
		}
	}

	/// <summary>
	/// ColumnCollection de colunas ordenadas (asc ou desc)...
	/// </summary>
	[Serializable]
	public class Index : ColumnCollection, ISerializable
	{
		public Boolean[] asc; // ordenao (para indices)
		public string Name;
		public Index(string Name) : base()
		{
			asc = new Boolean[0];
			this.Name = Name;
		}

		public void AddColumn(Column col, bool asc)
		{
			base.AddColumn(col);
			bool[] asc2 = new bool[m_Columns.GetLength(0)]; // o tamanho aqui ja aumentou...
			this.asc.CopyTo(asc2, 0);
			asc2[m_Columns.GetLength(0)-1] = asc;
			this.asc = asc2 ;
		}
		public override void DelColumn(Column col)
		{
			bool[] asc2 = new bool[m_Columns.GetLength(0)-1];
			int i=0, j=0;
			for (; i<=asc2.GetLength(0)-1; i++, j++) 
			{
				if (m_Columns[j].Equals(col)) 
					j++;
				asc2[i] = asc[j];
			}
			asc = asc2;
			base.DelColumn(col);
		}
		/// <summary>Construtor Serializao</summary>
		protected Index (SerializationInfo Info, StreamingContext Context) : base (Info, Context)
		{
			this.Name = Info.GetString ("Name");
			this.asc = Info.GetValue ("asc", typeof(Boolean[])) as Boolean[];
		}
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
			info.AddValue("Name", this.Name);
			info.AddValue("asc", this.asc);
		}
	}

	[Serializable]
	public class UniqueIndex : Index, ISerializable
	{
		public UniqueIndex(string Name) : base(Name)
		{
		}
		protected UniqueIndex (SerializationInfo Info, StreamingContext Context) : base (Info, Context)
		{
		}
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}
	}

	[Serializable]
	public class IEIndex : Index, ISerializable
	{
		public IEIndex(string Name) : base(Name)
		{
		}
		protected IEIndex (SerializationInfo Info, StreamingContext Context) : base (Info, Context)
		{
		}
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}
	}

	[Serializable]
	public class FKIndex : Index, ISerializable
	{
		public FKIndex(string Name) : base(Name)
		{
		}
		protected FKIndex (SerializationInfo Info, StreamingContext Context) : base (Info, Context)
		{
		}
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}
	}

	[Serializable]
	public class PKIndex : Index, ISerializable
	{
		public PKIndex(string Name) : base(Name)
		{
		}
		protected PKIndex (SerializationInfo Info, StreamingContext Context) : base (Info, Context)
		{
		}
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

	}
}