/*************************************************************************
 * ERWon - Entity Relationship for Windows or Not
 * Ricardo Drizin
 * 
 * Classe frmEditEntity
 * Janela de edio de Entidades
 * Ainda em desenvolvimento...
 ************************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ERWon
{
	/// <summary>
	/// Summary description for frmEditEntity.
	/// </summary>
	public class frmEditEntity : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabColumns;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.ComboBox cbo_Indexes;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Button btn_ok;
		private System.Windows.Forms.ImageList botoes;
		private System.Windows.Forms.Button btn_columns_delete;
		private System.Windows.Forms.Button btn_columns_rename;
		private System.Windows.Forms.Button btn_columns_new;
		private System.Windows.Forms.CheckBox cb_columns_notnull;
		private System.Windows.Forms.ComboBox cbo_columns_datatype;
		private System.Windows.Forms.Button btn_index_delete;
		private System.Windows.Forms.Button btn_index_rename;
		private System.Windows.Forms.Button btn_index_new;
		private System.Windows.Forms.Button btn_index_remove;
		private System.Windows.Forms.Button btn_index_add;
		private System.Windows.Forms.ComboBox cbo_relationship_parentupdate;
		private System.Windows.Forms.ComboBox cbo_relationship_parentdelete;
		private System.Windows.Forms.ListBox lb_relationship_columns;
		private System.Windows.Forms.ComboBox cbo_relationship_migratedindex;
		private System.Windows.Forms.ComboBox cbo_relationship;
		private System.Windows.Forms.Button btn_columns_up;
		private System.Windows.Forms.Button btn_columns_down;
		private System.Windows.Forms.Button btn_index_down;
		private System.Windows.Forms.Button btn_index_up;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ListBox lb_columns;
		private System.Windows.Forms.ListBox lb_index_membercols;
		private System.Windows.Forms.ListBox lb_index_availablecols;

		protected Entity entity;
		protected Index index;
		private System.Windows.Forms.ComboBox cbo_tables;
		private System.Windows.Forms.CheckBox cb_index_unique;
		private System.Windows.Forms.CheckBox cb_index_column_desc;
		protected IDocument m_Document;
		public frmEditEntity(Entity entity, MainForm mainForm, IDocument m_Document)
		{
			InitializeComponent();
			// Icone do aplicativo.
			//http://www.syncfusion.com/FAQ/WinForms/FAQ_c95c.asp#q774q
			Bitmap bmp = mainForm.Get_Toolbar().Images[9] as Bitmap; 
			this.Icon = Icon.FromHandle(bmp.GetHicon());  

			this.m_Document = m_Document;
			this.entity = entity;

			this.cbo_tables.Items.Clear();
			foreach (Box box in m_Document.Boxes)
			{
				Entity e = box as Entity;
				if (e!=null) this.cbo_tables.Items.Add(e.TableName);
				if (e==this.entity) this.cbo_tables.SelectedItem = this.cbo_tables.Items[this.cbo_tables.Items.Count-1];
			}
			UpdateColumns();

			foreach(Index idx in entity.m_Indexes)
			{
				this.cbo_Indexes.Items.Add(idx.Name);
			}
			if (this.cbo_Indexes.Items.Count>0) 
			{
				this.cbo_Indexes.SelectedItem = this.cbo_Indexes.Items[0];
				index = entity.m_Indexes[0];
			}
			UpdateIndex();
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmEditEntity));
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabColumns = new System.Windows.Forms.TabPage();
			this.btn_columns_down = new System.Windows.Forms.Button();
			this.botoes = new System.Windows.Forms.ImageList(this.components);
			this.btn_columns_up = new System.Windows.Forms.Button();
			this.btn_columns_delete = new System.Windows.Forms.Button();
			this.btn_columns_rename = new System.Windows.Forms.Button();
			this.btn_columns_new = new System.Windows.Forms.Button();
			this.cb_columns_notnull = new System.Windows.Forms.CheckBox();
			this.cbo_columns_datatype = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.lb_columns = new System.Windows.Forms.ListBox();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.btn_index_down = new System.Windows.Forms.Button();
			this.btn_index_up = new System.Windows.Forms.Button();
			this.cb_index_column_desc = new System.Windows.Forms.CheckBox();
			this.cb_index_unique = new System.Windows.Forms.CheckBox();
			this.btn_index_delete = new System.Windows.Forms.Button();
			this.btn_index_rename = new System.Windows.Forms.Button();
			this.btn_index_new = new System.Windows.Forms.Button();
			this.btn_index_remove = new System.Windows.Forms.Button();
			this.btn_index_add = new System.Windows.Forms.Button();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.lb_index_membercols = new System.Windows.Forms.ListBox();
			this.lb_index_availablecols = new System.Windows.Forms.ListBox();
			this.label6 = new System.Windows.Forms.Label();
			this.cbo_Indexes = new System.Windows.Forms.ComboBox();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.cbo_relationship_parentupdate = new System.Windows.Forms.ComboBox();
			this.label13 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.cbo_relationship_parentdelete = new System.Windows.Forms.ComboBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label8 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.lb_relationship_columns = new System.Windows.Forms.ListBox();
			this.cbo_relationship_migratedindex = new System.Windows.Forms.ComboBox();
			this.label7 = new System.Windows.Forms.Label();
			this.cbo_relationship = new System.Windows.Forms.ComboBox();
			this.btn_ok = new System.Windows.Forms.Button();
			this.cbo_tables = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.tabControl1.SuspendLayout();
			this.tabColumns.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabColumns);
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.Location = new System.Drawing.Point(24, 72);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(576, 376);
			this.tabControl1.TabIndex = 5;
			// 
			// tabColumns
			// 
			this.tabColumns.Controls.Add(this.btn_columns_down);
			this.tabColumns.Controls.Add(this.btn_columns_up);
			this.tabColumns.Controls.Add(this.btn_columns_delete);
			this.tabColumns.Controls.Add(this.btn_columns_rename);
			this.tabColumns.Controls.Add(this.btn_columns_new);
			this.tabColumns.Controls.Add(this.cb_columns_notnull);
			this.tabColumns.Controls.Add(this.cbo_columns_datatype);
			this.tabColumns.Controls.Add(this.label2);
			this.tabColumns.Controls.Add(this.label1);
			this.tabColumns.Controls.Add(this.lb_columns);
			this.tabColumns.Location = new System.Drawing.Point(4, 22);
			this.tabColumns.Name = "tabColumns";
			this.tabColumns.Size = new System.Drawing.Size(568, 350);
			this.tabColumns.TabIndex = 0;
			this.tabColumns.Text = "Columns";
			// 
			// btn_columns_down
			// 
			this.btn_columns_down.ImageIndex = 4;
			this.btn_columns_down.ImageList = this.botoes;
			this.btn_columns_down.Location = new System.Drawing.Point(248, 80);
			this.btn_columns_down.Name = "btn_columns_down";
			this.btn_columns_down.Size = new System.Drawing.Size(24, 23);
			this.btn_columns_down.TabIndex = 14;
			this.btn_columns_down.Click += new System.EventHandler(this.btn_columns_down_Click);
			// 
			// botoes
			// 
			this.botoes.ImageSize = new System.Drawing.Size(26, 26);
			this.botoes.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("botoes.ImageStream")));
			this.botoes.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// btn_columns_up
			// 
			this.btn_columns_up.ImageIndex = 0;
			this.btn_columns_up.ImageList = this.botoes;
			this.btn_columns_up.Location = new System.Drawing.Point(248, 48);
			this.btn_columns_up.Name = "btn_columns_up";
			this.btn_columns_up.Size = new System.Drawing.Size(24, 23);
			this.btn_columns_up.TabIndex = 13;
			this.btn_columns_up.Click += new System.EventHandler(this.btn_columns_up_Click);
			// 
			// btn_columns_delete
			// 
			this.btn_columns_delete.Location = new System.Drawing.Point(176, 272);
			this.btn_columns_delete.Name = "btn_columns_delete";
			this.btn_columns_delete.Size = new System.Drawing.Size(56, 23);
			this.btn_columns_delete.TabIndex = 12;
			this.btn_columns_delete.Text = "Delete";
			this.btn_columns_delete.Click += new System.EventHandler(this.btn_columns_delete_Click);
			// 
			// btn_columns_rename
			// 
			this.btn_columns_rename.Location = new System.Drawing.Point(96, 272);
			this.btn_columns_rename.Name = "btn_columns_rename";
			this.btn_columns_rename.Size = new System.Drawing.Size(56, 23);
			this.btn_columns_rename.TabIndex = 11;
			this.btn_columns_rename.Text = "Rename";
			this.btn_columns_rename.Click += new System.EventHandler(this.btn_columns_rename_Click);
			// 
			// btn_columns_new
			// 
			this.btn_columns_new.Location = new System.Drawing.Point(16, 272);
			this.btn_columns_new.Name = "btn_columns_new";
			this.btn_columns_new.Size = new System.Drawing.Size(56, 23);
			this.btn_columns_new.TabIndex = 10;
			this.btn_columns_new.Text = "New";
			this.btn_columns_new.Click += new System.EventHandler(this.btn_columns_new_Click);
			// 
			// cb_columns_notnull
			// 
			this.cb_columns_notnull.Location = new System.Drawing.Point(392, 120);
			this.cb_columns_notnull.Name = "cb_columns_notnull";
			this.cb_columns_notnull.TabIndex = 9;
			this.cb_columns_notnull.Text = "NOT NULL";
			this.cb_columns_notnull.CheckedChanged += new System.EventHandler(this.cb_columns_notnull_CheckedChanged);
			// 
			// cbo_columns_datatype
			// 
			this.cbo_columns_datatype.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbo_columns_datatype.Items.AddRange(new object[] {
																	  "Autonumber",
																	  "Byte",
																	  "Currency",
																	  "Date/Time",
																	  "Decimal",
																	  "Double",
																	  "Integer",
																	  "Long Integer",
																	  "Replication ID",
																	  "Single",
																	  "String",
																	  "Yes/No"});
			this.cbo_columns_datatype.Location = new System.Drawing.Point(392, 88);
			this.cbo_columns_datatype.Name = "cbo_columns_datatype";
			this.cbo_columns_datatype.Size = new System.Drawing.Size(121, 21);
			this.cbo_columns_datatype.TabIndex = 8;
			this.cbo_columns_datatype.SelectedIndexChanged += new System.EventHandler(this.cbo_columns_datatype_SelectedIndexChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(392, 56);
			this.label2.Name = "label2";
			this.label2.TabIndex = 7;
			this.label2.Text = "Datatype";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.TabIndex = 6;
			this.label1.Text = "Columns";
			// 
			// lb_columns
			// 
			this.lb_columns.Items.AddRange(new object[] {
															"ID_EMPLOYEE",
															"NAME",
															"BIRTHDATE",
															"SSN",
															"ID_DEPT"});
			this.lb_columns.Location = new System.Drawing.Point(16, 48);
			this.lb_columns.Name = "lb_columns";
			this.lb_columns.Size = new System.Drawing.Size(216, 212);
			this.lb_columns.TabIndex = 5;
			this.lb_columns.SelectedIndexChanged += new System.EventHandler(this.lb_columns_SelectedIndexChanged);
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.btn_index_down);
			this.tabPage1.Controls.Add(this.btn_index_up);
			this.tabPage1.Controls.Add(this.cb_index_column_desc);
			this.tabPage1.Controls.Add(this.cb_index_unique);
			this.tabPage1.Controls.Add(this.btn_index_delete);
			this.tabPage1.Controls.Add(this.btn_index_rename);
			this.tabPage1.Controls.Add(this.btn_index_new);
			this.tabPage1.Controls.Add(this.btn_index_remove);
			this.tabPage1.Controls.Add(this.btn_index_add);
			this.tabPage1.Controls.Add(this.label5);
			this.tabPage1.Controls.Add(this.label4);
			this.tabPage1.Controls.Add(this.lb_index_membercols);
			this.tabPage1.Controls.Add(this.lb_index_availablecols);
			this.tabPage1.Controls.Add(this.label6);
			this.tabPage1.Controls.Add(this.cbo_Indexes);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(568, 350);
			this.tabPage1.TabIndex = 1;
			this.tabPage1.Text = "Indexes";
			// 
			// btn_index_down
			// 
			this.btn_index_down.ImageIndex = 4;
			this.btn_index_down.ImageList = this.botoes;
			this.btn_index_down.Location = new System.Drawing.Point(392, 144);
			this.btn_index_down.Name = "btn_index_down";
			this.btn_index_down.Size = new System.Drawing.Size(24, 23);
			this.btn_index_down.TabIndex = 23;
			this.btn_index_down.Click += new System.EventHandler(this.btn_index_down_Click);
			// 
			// btn_index_up
			// 
			this.btn_index_up.ImageIndex = 0;
			this.btn_index_up.ImageList = this.botoes;
			this.btn_index_up.Location = new System.Drawing.Point(392, 112);
			this.btn_index_up.Name = "btn_index_up";
			this.btn_index_up.Size = new System.Drawing.Size(24, 23);
			this.btn_index_up.TabIndex = 22;
			this.btn_index_up.Click += new System.EventHandler(this.btn_index_up_Click);
			// 
			// cb_index_column_desc
			// 
			this.cb_index_column_desc.Checked = true;
			this.cb_index_column_desc.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cb_index_column_desc.Enabled = false;
			this.cb_index_column_desc.Location = new System.Drawing.Point(264, 304);
			this.cb_index_column_desc.Name = "cb_index_column_desc";
			this.cb_index_column_desc.TabIndex = 21;
			this.cb_index_column_desc.Text = "DESC";
			this.cb_index_column_desc.CheckedChanged += new System.EventHandler(this.cb_index_column_desc_CheckedChanged);
			// 
			// cb_index_unique
			// 
			this.cb_index_unique.Checked = true;
			this.cb_index_unique.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cb_index_unique.Enabled = false;
			this.cb_index_unique.Location = new System.Drawing.Point(16, 48);
			this.cb_index_unique.Name = "cb_index_unique";
			this.cb_index_unique.TabIndex = 20;
			this.cb_index_unique.Text = "Unique";
			this.cb_index_unique.CheckedChanged += new System.EventHandler(this.cb_index_unique_CheckedChanged);
			// 
			// btn_index_delete
			// 
			this.btn_index_delete.Location = new System.Drawing.Point(456, 112);
			this.btn_index_delete.Name = "btn_index_delete";
			this.btn_index_delete.Size = new System.Drawing.Size(64, 23);
			this.btn_index_delete.TabIndex = 19;
			this.btn_index_delete.Text = "Delete";
			this.btn_index_delete.Click += new System.EventHandler(this.btn_index_delete_Click);
			// 
			// btn_index_rename
			// 
			this.btn_index_rename.Location = new System.Drawing.Point(456, 80);
			this.btn_index_rename.Name = "btn_index_rename";
			this.btn_index_rename.Size = new System.Drawing.Size(64, 23);
			this.btn_index_rename.TabIndex = 18;
			this.btn_index_rename.Text = "Rename";
			this.btn_index_rename.Click += new System.EventHandler(this.btn_index_rename_Click);
			// 
			// btn_index_new
			// 
			this.btn_index_new.Location = new System.Drawing.Point(456, 48);
			this.btn_index_new.Name = "btn_index_new";
			this.btn_index_new.Size = new System.Drawing.Size(64, 24);
			this.btn_index_new.TabIndex = 17;
			this.btn_index_new.Text = "New";
			this.btn_index_new.Click += new System.EventHandler(this.btn_index_new_Click);
			// 
			// btn_index_remove
			// 
			this.btn_index_remove.ImageIndex = 6;
			this.btn_index_remove.ImageList = this.botoes;
			this.btn_index_remove.Location = new System.Drawing.Point(192, 176);
			this.btn_index_remove.Name = "btn_index_remove";
			this.btn_index_remove.Size = new System.Drawing.Size(24, 23);
			this.btn_index_remove.TabIndex = 5;
			this.btn_index_remove.Click += new System.EventHandler(this.btn_index_remove_Click);
			// 
			// btn_index_add
			// 
			this.btn_index_add.ImageIndex = 2;
			this.btn_index_add.ImageList = this.botoes;
			this.btn_index_add.Location = new System.Drawing.Point(192, 144);
			this.btn_index_add.Name = "btn_index_add";
			this.btn_index_add.Size = new System.Drawing.Size(24, 23);
			this.btn_index_add.TabIndex = 4;
			this.btn_index_add.Click += new System.EventHandler(this.btn_index_add_Click);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(264, 80);
			this.label5.Name = "label5";
			this.label5.TabIndex = 3;
			this.label5.Text = "Index Members";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 80);
			this.label4.Name = "label4";
			this.label4.TabIndex = 2;
			this.label4.Text = "Available Columns";
			// 
			// lb_index_membercols
			// 
			this.lb_index_membercols.Items.AddRange(new object[] {
																	 "ID_EMPLOYEE"});
			this.lb_index_membercols.Location = new System.Drawing.Point(264, 112);
			this.lb_index_membercols.Name = "lb_index_membercols";
			this.lb_index_membercols.Size = new System.Drawing.Size(120, 186);
			this.lb_index_membercols.TabIndex = 1;
			this.lb_index_membercols.SelectedIndexChanged += new System.EventHandler(this.lb_index_membercols_SelectedIndexChanged);
			// 
			// lb_index_availablecols
			// 
			this.lb_index_availablecols.Items.AddRange(new object[] {
																		"NAME",
																		"BIRTHDATE",
																		"SSN",
																		"ID_DEPT"});
			this.lb_index_availablecols.Location = new System.Drawing.Point(16, 112);
			this.lb_index_availablecols.Name = "lb_index_availablecols";
			this.lb_index_availablecols.Size = new System.Drawing.Size(120, 186);
			this.lb_index_availablecols.TabIndex = 0;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 16);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 23);
			this.label6.TabIndex = 16;
			this.label6.Text = "Index";
			// 
			// cbo_Indexes
			// 
			this.cbo_Indexes.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbo_Indexes.Location = new System.Drawing.Point(72, 16);
			this.cbo_Indexes.Name = "cbo_Indexes";
			this.cbo_Indexes.Size = new System.Drawing.Size(456, 21);
			this.cbo_Indexes.TabIndex = 15;
			this.cbo_Indexes.SelectedIndexChanged += new System.EventHandler(this.cbo_Indexes_SelectedIndexChanged);
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.groupBox2);
			this.tabPage2.Controls.Add(this.groupBox1);
			this.tabPage2.Controls.Add(this.label7);
			this.tabPage2.Controls.Add(this.cbo_relationship);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(568, 350);
			this.tabPage2.TabIndex = 2;
			this.tabPage2.Text = "Relationships";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.cbo_relationship_parentupdate);
			this.groupBox2.Controls.Add(this.label13);
			this.groupBox2.Controls.Add(this.label11);
			this.groupBox2.Controls.Add(this.cbo_relationship_parentdelete);
			this.groupBox2.Location = new System.Drawing.Point(16, 240);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(520, 104);
			this.groupBox2.TabIndex = 27;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Triggers";
			// 
			// cbo_relationship_parentupdate
			// 
			this.cbo_relationship_parentupdate.Items.AddRange(new object[] {
																			   "CASCADE",
																			   "NONE"});
			this.cbo_relationship_parentupdate.Location = new System.Drawing.Point(96, 72);
			this.cbo_relationship_parentupdate.Name = "cbo_relationship_parentupdate";
			this.cbo_relationship_parentupdate.Size = new System.Drawing.Size(160, 21);
			this.cbo_relationship_parentupdate.TabIndex = 30;
			this.cbo_relationship_parentupdate.Text = "CASCADE";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(16, 72);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(80, 23);
			this.label13.TabIndex = 29;
			this.label13.Text = "Parent Update";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(16, 24);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(80, 23);
			this.label11.TabIndex = 25;
			this.label11.Text = "Parent Delete";
			// 
			// cbo_relationship_parentdelete
			// 
			this.cbo_relationship_parentdelete.Items.AddRange(new object[] {
																			   "CASCADE",
																			   "NONE"});
			this.cbo_relationship_parentdelete.Location = new System.Drawing.Point(96, 24);
			this.cbo_relationship_parentdelete.Name = "cbo_relationship_parentdelete";
			this.cbo_relationship_parentdelete.Size = new System.Drawing.Size(160, 21);
			this.cbo_relationship_parentdelete.TabIndex = 24;
			this.cbo_relationship_parentdelete.Text = "CASCADE";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label8);
			this.groupBox1.Controls.Add(this.label10);
			this.groupBox1.Controls.Add(this.label9);
			this.groupBox1.Controls.Add(this.lb_relationship_columns);
			this.groupBox1.Controls.Add(this.cbo_relationship_migratedindex);
			this.groupBox1.Location = new System.Drawing.Point(16, 48);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(520, 184);
			this.groupBox1.TabIndex = 26;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Migrated Index";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(16, 24);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(80, 23);
			this.label8.TabIndex = 20;
			this.label8.Text = "Migrated Index";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(208, 48);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(100, 16);
			this.label10.TabIndex = 23;
			this.label10.Text = "Alias";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(16, 48);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(100, 16);
			this.label9.TabIndex = 22;
			this.label9.Text = "Migrated Columns";
			// 
			// lb_relationship_columns
			// 
			this.lb_relationship_columns.ColumnWidth = 30;
			this.lb_relationship_columns.Items.AddRange(new object[] {
																		 "ID_DEPARTMENT"});
			this.lb_relationship_columns.Location = new System.Drawing.Point(24, 80);
			this.lb_relationship_columns.MultiColumn = true;
			this.lb_relationship_columns.Name = "lb_relationship_columns";
			this.lb_relationship_columns.Size = new System.Drawing.Size(344, 95);
			this.lb_relationship_columns.TabIndex = 21;
			// 
			// cbo_relationship_migratedindex
			// 
			this.cbo_relationship_migratedindex.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbo_relationship_migratedindex.Items.AddRange(new object[] {
																				"(Department) PK_Department"});
			this.cbo_relationship_migratedindex.Location = new System.Drawing.Point(112, 24);
			this.cbo_relationship_migratedindex.Name = "cbo_relationship_migratedindex";
			this.cbo_relationship_migratedindex.Size = new System.Drawing.Size(392, 21);
			this.cbo_relationship_migratedindex.TabIndex = 19;
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 16);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(80, 23);
			this.label7.TabIndex = 18;
			this.label7.Text = "Relationship";
			// 
			// cbo_relationship
			// 
			this.cbo_relationship.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbo_relationship.Items.AddRange(new object[] {
																  "Department R23 Employee"});
			this.cbo_relationship.Location = new System.Drawing.Point(104, 16);
			this.cbo_relationship.Name = "cbo_relationship";
			this.cbo_relationship.Size = new System.Drawing.Size(424, 21);
			this.cbo_relationship.TabIndex = 17;
			// 
			// btn_ok
			// 
			this.btn_ok.Location = new System.Drawing.Point(40, 456);
			this.btn_ok.Name = "btn_ok";
			this.btn_ok.Size = new System.Drawing.Size(56, 23);
			this.btn_ok.TabIndex = 13;
			this.btn_ok.Text = "OK";
			this.btn_ok.Click += new System.EventHandler(this.btn_ok_Click);
			// 
			// cbo_tables
			// 
			this.cbo_tables.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cbo_tables.Items.AddRange(new object[] {
															"Employee",
															"Department",
															"Company",
															"Location"});
			this.cbo_tables.Location = new System.Drawing.Point(72, 24);
			this.cbo_tables.Name = "cbo_tables";
			this.cbo_tables.Size = new System.Drawing.Size(512, 21);
			this.cbo_tables.TabIndex = 9;
			this.cbo_tables.SelectedIndexChanged += new System.EventHandler(this.cbo_tables_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 23);
			this.label3.TabIndex = 10;
			this.label3.Text = "Entity";
			// 
			// frmEditEntity
			// 
			this.AcceptButton = this.btn_ok;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 494);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.cbo_tables);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.btn_ok);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "frmEditEntity";
			this.Text = "Edit Table";
			this.tabControl1.ResumeLayout(false);
			this.tabColumns.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		protected void UpdateColumns()
		{
			for (int i=0; i< this.cbo_tables.Items.Count; i++)
				if (this.cbo_tables.Items[i].ToString().Equals(this.entity.TableName))
					this.cbo_tables.SelectedItem = this.cbo_tables.Items[i];

			this.lb_columns.Items.Clear();
			for (int i=0; i < this.entity.m_Cols.m_Columns.GetLength(0); i++)
				this.lb_columns.Items.Add(entity.m_Cols.m_Columns[i].ColumnName);
		}

		// se alterar coluna selecionda, atualizar tipo de dados e NOT NULL
		private void lb_columns_SelectedIndexChanged(object sender, EventArgs e)
		{
			string coluna = this.lb_columns.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (entity.m_Cols.m_Columns[i].ColumnName.Equals(coluna))
				{
					this.cbo_columns_datatype.Text = entity.m_Cols.m_Columns[i].typeName;
					this.cb_columns_notnull.Checked = entity.m_Cols.m_Columns[i].NOTNULL;
					break;
				}
		}

		// se alterar tipo de dados, atualizar coluna selecionada.
		private void cbo_columns_datatype_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (this.lb_columns.SelectedItem==null) return;
			string coluna = this.lb_columns.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (entity.m_Cols.m_Columns[i].ColumnName.Equals(coluna))
				{
					entity.m_Cols.m_Columns[i].typeName = this.cbo_columns_datatype.Text;
					break;
				}
		}

		// se alterar notnull, atualizar coluna selecionada.
		private void cb_columns_notnull_CheckedChanged(object sender, EventArgs e)
		{
			if (this.lb_columns.SelectedItem==null) return;
			string coluna = this.lb_columns.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (entity.m_Cols.m_Columns[i].ColumnName.Equals(coluna))
				{
					entity.m_Cols.m_Columns[i].NOTNULL = this.cb_columns_notnull.Checked;
					break;
				}
		}

		private void btn_columns_up_Click(object sender, EventArgs e)
		{
			if (this.lb_columns.SelectedItem==null) return;
			string coluna = this.lb_columns.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (entity.m_Cols.m_Columns[i].ColumnName.Equals(coluna))
				{
					if (i>0)
					{
						Column tmp = entity.m_Cols.m_Columns[i-1];
						entity.m_Cols.m_Columns[i-1] = entity.m_Cols.m_Columns[i];
						entity.m_Cols.m_Columns[i] = tmp;
						UpdateColumns();
					}
					break;
				}
			SelectColumn(coluna);
		}

		private void btn_columns_down_Click(object sender, EventArgs e)
		{
			if (this.lb_columns.SelectedItem==null) return;
			string coluna = this.lb_columns.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (entity.m_Cols.m_Columns[i].ColumnName.Equals(coluna))
				{
					if (i < this.entity.m_Cols.m_Columns.GetLength(0) - 1)
					{
						Column tmp = entity.m_Cols.m_Columns[i+1];
						entity.m_Cols.m_Columns[i+1] = entity.m_Cols.m_Columns[i];
						entity.m_Cols.m_Columns[i] = tmp;
						UpdateColumns();
					}
					break;
				}
			SelectColumn(coluna);
		}
		private void SelectColumn(string coluna) 
		{
			for (int i=0; i<this.lb_columns.Items.Count; i++)
				if (this.lb_columns.Items[i].ToString().Equals(coluna))
					lb_columns.SelectedItem = lb_columns.Items[i];
		}

		private void btn_ok_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btn_columns_rename_Click(object sender, EventArgs e)
		{
			if (this.lb_columns.SelectedItem==null) return;
			string coluna = this.lb_columns.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (entity.m_Cols.m_Columns[i].ColumnName.Equals(coluna))
				{
					//Inputbox no existe em C#...
					// http://www.dotnet247.com/247reference/msgs/46/234771.aspx
					// ou
					//http://www.dotnet247.com/247reference/msgs/24/122621.aspx
					string novonome = Microsoft.VisualBasic.Interaction.InputBox("New name:","Rename",coluna, 100, 100);
					if ((novonome!=null) && (novonome.Length>0))
						entity.m_Cols.m_Columns[i].ColumnName = novonome;
					UpdateColumns();
					break;
				}
			SelectColumn(coluna);
		}

		private void btn_columns_delete_Click(object sender, EventArgs e)
		{
			if (this.lb_columns.SelectedItem==null) return;
			string coluna = this.lb_columns.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (entity.m_Cols.m_Columns[i].ColumnName.Equals(coluna))
				{
					entity.m_Cols.DelColumn(entity.m_Cols.m_Columns[i]);
					//TODO - apagar tambm a coluna de outros ndices (e propagar para respectivas FKs), etc..
					// talvez dentro de DelColumn, verificando se o tipo de ColumnCollection  PK, Indice, etc...
					UpdateColumns();
					break;
				}
		}

		private void btn_columns_new_Click(object sender, EventArgs e)
		{
			string novonome = Microsoft.VisualBasic.Interaction.InputBox("Column Name:","New column", "ColumnName", 100, 100);
			if ((novonome!=null) && (novonome.Length>0))
				entity.m_Cols.AddColumn(new Column(novonome, "Integer", false));
			UpdateColumns();
			SelectColumn(novonome);
		}

		private void cbo_tables_SelectedIndexChanged(object sender, EventArgs e)
		{
			string tabela = this.cbo_tables.SelectedItem.ToString();
			foreach (Box b in m_Document.Boxes)
			{
				Entity ent = b as Entity;
				if ((ent != null) && ent.TableName.Equals(tabela)) 
				{
					this.entity = ent;
					break;
				}
			}
			this.UpdateColumns();
		}

		private void cbo_Indexes_SelectedIndexChanged(object sender, EventArgs e)
		{
			string indice = this.cbo_Indexes.SelectedItem.ToString();
			foreach (Index idx in entity.m_Indexes)
			{
				if (idx.Name == indice)
				{
					this.index = idx;
					break;
				}
			}
			this.UpdateIndex();
		}

		protected void UpdateIndex()
		{
			if (this.index == null)
				return;
			//TODO - checkbox (unique)
			//TODO - indexmembers DESC ou nao
			//TODO - mover pra cima ou pra baixo, adicionar/remover

			if ((this.index as PKIndex)!=null)
			{
				this.cb_index_unique.Checked=true;
				this.cb_index_unique.Enabled=false;
			}
			else if ((this.index as UniqueIndex)!=null)
			{
				this.cb_index_unique.Checked=true;
				this.cb_index_unique.Enabled=true;
			}
			else 
			{
				this.cb_index_unique.Checked=false;
				this.cb_index_unique.Enabled=true;
			}


			this.lb_index_availablecols.Items.Clear();
			this.lb_index_membercols.Items.Clear();
			for (int i=0; i < this.entity.m_Cols.m_Columns.GetLength(0); i++)
			{
				bool ismember=false;
				for (int j=0; j < this.index.m_Columns.GetLength(0); j++)
					if (this.entity.m_Cols.m_Columns[i].ColumnName ==
						this.index.m_Columns[j].ColumnName)
						ismember=true;
				if (ismember) {}
					// preciso inserir na ordem...
					//this.lb_index_membercols.Items.Add(this.entity.m_Cols.m_Columns[i].ColumnName);
				else
					this.lb_index_availablecols.Items.Add(this.entity.m_Cols.m_Columns[i].ColumnName);
			}
			for (int j=0; j < this.index.m_Columns.GetLength(0); j++)
				this.lb_index_membercols.Items.Add(this.index.m_Columns[j].ColumnName);
		}

		private void cb_index_unique_CheckedChanged(object sender, EventArgs e)
		{
			// TODO - converter indice unico para nao unico, e vice-versa.
		}

		private void lb_index_membercols_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (this.lb_index_membercols.SelectedItem==null) return;
			string coluna = this.lb_index_membercols.SelectedItem.ToString();
			for (int i=0; i<this.index.m_Columns.GetLength(0); i++)
				if (this.index.m_Columns[i].ColumnName == coluna) 
				{
					this.cb_index_column_desc.Enabled=true;
					this.cb_index_column_desc.Checked = !this.index.asc[i];
					break;
				}
		}

		private void cb_index_column_desc_CheckedChanged(object sender, EventArgs e)
		{
			if (this.lb_index_membercols.SelectedItem==null) return;
			string coluna = this.lb_index_membercols.SelectedItem.ToString();
			for (int i=0; i<this.index.m_Columns.GetLength(0); i++)
				if (this.index.m_Columns[i].ColumnName == coluna)
				{
					this.index.asc[i] = !this.cb_index_column_desc.Checked;
					break;
				}
		}

		private void btn_index_add_Click(object sender, System.EventArgs e)
		{
			if (this.lb_index_availablecols.SelectedItem==null) return;
			string coluna = this.lb_index_availablecols.SelectedItem.ToString();
			for (int i=0; i<this.entity.m_Cols.m_Columns.GetLength(0); i++)
				if (this.entity.m_Cols.m_Columns[i].ColumnName==coluna) 
				{
					this.index.AddColumn(this.entity.m_Cols.m_Columns[i], true);
					break;
				}
			this.UpdateIndex();
		}

		private void btn_index_remove_Click(object sender, System.EventArgs e)
		{
			if (this.lb_index_membercols.SelectedItem==null) return;
			string coluna = this.lb_index_membercols.SelectedItem.ToString();
			for (int i=0; i<this.index.m_Columns.GetLength(0); i++)
				if (this.index.m_Columns[i].ColumnName==coluna) 
				{
					this.index.DelColumn(this.index.m_Columns[i]);
					break;
				}
			this.UpdateIndex();
		}

		private void btn_index_up_Click(object sender, System.EventArgs e)
		{
			if (this.lb_index_membercols.SelectedItem==null) return;
			string coluna = this.lb_index_membercols.SelectedItem.ToString();
			for (int i=0; i<this.index.m_Columns.GetLength(0); i++)
				if (this.index.m_Columns[i].ColumnName==coluna) 
				{
					if (i>0) 
					{
						Column tmp = this.index.m_Columns[i];
						bool tmp2 = this.index.asc[i];
						this.index.m_Columns[i] = this.index.m_Columns[i-1];
						this.index.asc[i] = this.index.asc[i-1];
						this.index.m_Columns[i-1] = tmp;
						this.index.asc[i-1] = tmp2;
					}
					break;
				}
			this.UpdateIndex();
		}

		private void btn_index_down_Click(object sender, System.EventArgs e)
		{
			if (this.lb_index_membercols.SelectedItem==null) return;
			string coluna = this.lb_index_membercols.SelectedItem.ToString();
			for (int i=0; i<this.index.m_Columns.GetLength(0); i++)
				if (this.index.m_Columns[i].ColumnName==coluna) 
				{
					if (i<this.index.m_Columns.GetLength(0)-1) 
					{
						Column tmp = this.index.m_Columns[i];
						bool tmp2 = this.index.asc[i];
						this.index.m_Columns[i] = this.index.m_Columns[i+1];
						this.index.asc[i] = this.index.asc[i+1];
						this.index.m_Columns[i+1] = tmp;
						this.index.asc[i+1] = tmp2;
					}
					break;
				}
			this.UpdateIndex();
		}

		private void btn_index_new_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("Recurso no implementado... :(");
		}

		private void btn_index_rename_Click(object sender, System.EventArgs e)
		{
				string novonome = Microsoft.VisualBasic.Interaction.InputBox("New name:","Rename",this.index.Name, 100, 100);
				if ((novonome!=null) && (novonome.Length>0))
					this.index.Name = novonome;
		}

		private void btn_index_delete_Click(object sender, System.EventArgs e)
		{
			if ((this.index as PKIndex)!=null) 
			{
				MessageBox.Show("Table MUST have a Primary Key");
				return;
			}
			for (int i=0; i<this.entity.m_Indexes.GetLength(0); i++)
				if (this.index==this.entity.m_Indexes[i])
					MessageBox.Show("recurso no implementado... :(");
		}
	}
}

// TODO - http://www.codeproject.com/cs/combobox/multicolumnlistbox.asp?df=100&forumid=4023&exp=0&select=672054&tid=672054
// TODO - multicolumn editbox.